/*++

Copyright (c) 2008 Microsoft Corporation, All Rights Reserved

Module Name:

    gpioctl.h

Abstract:

    Include file for Generic Port I/O Example Driver

--*/

#if     !defined(__GPIOCTL_H__)
#define __GPIOCTL_H__

//
// Define the IOCTL codes we will use.  The IOCTL code contains a command
// identifier, plus other information about the device, the type of access
// with which the file must have been opened, and the type of buffering.
//

//
// Device type           -- in the "User Defined" range."
//

#define GPIO_TYPE 40003

// The IOCTL function codes from 0x800 to 0xFFF are for customer use.

#define IOCTL_P60xBO_XGPIO_GET_LEVEL \
    CTL_CODE( GPIO_TYPE, 0x901, METHOD_BUFFERED, FILE_READ_ACCESS )

#define IOCTL_P60xBO_XGPIO_GET_DIR \
    CTL_CODE( GPIO_TYPE, 0x902, METHOD_BUFFERED, FILE_READ_ACCESS )

#define IOCTL_P60xBO_XGPIO_SET_LEVEL \
    CTL_CODE(GPIO_TYPE,  0x911, METHOD_BUFFERED, FILE_WRITE_ACCESS)

#define IOCTL_P60xBO_XGPIO_SET_DIR \
    CTL_CODE(GPIO_TYPE,  0x912, METHOD_BUFFERED, FILE_WRITE_ACCESS)

typedef struct  _XGPIOPORT_WRITE_INPUT {
    union   {               // Data to be output to port
        UCHAR   CharData[2];
    };
}   XGPIOPORT_WRITE_INPUT;

#endif


